]> CyberLeo.Net >> Repos - FreeBSD/FreeBSD.git/blob - etc/rc.subr
Partially revert r328780
[FreeBSD/FreeBSD.git] / etc / rc.subr
1 # $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2 # $FreeBSD$
3 #
4 # Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
5 # All rights reserved.
6 #
7 # This code is derived from software contributed to The NetBSD Foundation
8 # by Luke Mewburn.
9 #
10 # Redistribution and use in source and binary forms, with or without
11 # modification, are permitted provided that the following conditions
12 # are met:
13 # 1. Redistributions of source code must retain the above copyright
14 #    notice, this list of conditions and the following disclaimer.
15 # 2. Redistributions in binary form must reproduce the above copyright
16 #    notice, this list of conditions and the following disclaimer in the
17 #    documentation and/or other materials provided with the distribution.
18 #
19 # THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
20 # ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
21 # TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
22 # PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
23 # BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
24 # CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
25 # SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
26 # INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
27 # CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
28 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
29 # POSSIBILITY OF SUCH DAMAGE.
30 #
31 # rc.subr
32 #       functions used by various rc scripts
33 #
34
35 : ${RC_PID:=$$}; export RC_PID
36
37 #
38 #       Operating System dependent/independent variables
39 #
40
41 if [ -n "${_rc_subr_loaded}" ]; then
42         return
43 fi
44
45 _rc_subr_loaded="YES"
46
47 SYSCTL="/sbin/sysctl"
48 SYSCTL_N="${SYSCTL} -n"
49 SYSCTL_W="${SYSCTL}"
50 PROTECT="/usr/bin/protect"
51 ID="/usr/bin/id"
52 IDCMD="if [ -x $ID ]; then $ID -un; fi"
53 PS="/bin/ps -ww"
54 JID=0
55
56 #
57 #       functions
58 #       ---------
59
60 # list_vars pattern
61 #       List vars matching pattern.
62
63 list_vars()
64 {
65         set | { while read LINE; do
66                 var="${LINE%%=*}"
67                 case "$var" in
68                 "$LINE"|*[!a-zA-Z0-9_]*) continue ;;
69                 $1) echo $var
70                 esac
71         done; }
72 }
73
74 # set_rcvar [var] [defval] [desc]
75 #
76 #       Echo or define a rc.conf(5) variable name.  Global variable
77 #       $rcvars is used.
78 #
79 #       If no argument is specified, echo "${name}_enable".
80 #
81 #       If only a var is specified, echo "${var}_enable".
82 #
83 #       If var and defval are specified, the ${var} is defined as
84 #       rc.conf(5) variable and the default value is ${defvar}.  An
85 #       optional argument $desc can also be specified to add a
86 #       description for that.
87 #
88 set_rcvar()
89 {
90         local _var
91
92         case $# in
93         0)      echo ${name}_enable ;;
94         1)      echo ${1}_enable ;;
95         *)
96                 debug "set_rcvar: \$$1=$2 is added" \
97                     " as a rc.conf(5) variable."
98                 _var=$1
99                 rcvars="${rcvars# } $_var"
100                 eval ${_var}_defval=\"$2\"
101                 shift 2
102                 eval ${_var}_desc=\"$*\"
103         ;;
104         esac
105 }
106
107 # set_rcvar_obsolete oldvar [newvar] [msg]
108 #       Define obsolete variable.
109 #       Global variable $rcvars_obsolete is used.
110 #
111 set_rcvar_obsolete()
112 {
113         local _var
114         _var=$1
115         debug "set_rcvar_obsolete: \$$1(old) -> \$$2(new) is defined"
116
117         rcvars_obsolete="${rcvars_obsolete# } $1"
118         eval ${1}_newvar=\"$2\"
119         shift 2
120         eval ${_var}_obsolete_msg=\"$*\"
121 }
122
123 #
124 # force_depend script [rcvar]
125 #       Force a service to start. Intended for use by services
126 #       to resolve dependency issues.
127 #       $1 - filename of script, in /etc/rc.d, to run
128 #       $2 - name of the script's rcvar (minus the _enable)
129 #
130 force_depend()
131 {
132         local _depend _dep_rcvar
133
134         _depend="$1"
135         _dep_rcvar="${2:-$1}_enable"
136
137         [ -n "$rc_fast" ] && ! checkyesno always_force_depends &&
138             checkyesno $_dep_rcvar && return 0
139
140         /etc/rc.d/${_depend} forcestatus >/dev/null 2>&1 && return 0
141
142         info "${name} depends on ${_depend}, which will be forced to start."
143         if ! /etc/rc.d/${_depend} forcestart; then
144                 warn "Unable to force ${_depend}. It may already be running."
145                 return 1
146         fi
147 }
148
149 #
150 # checkyesno var
151 #       Test $1 variable, and warn if not set to YES or NO.
152 #       Return 0 if it's "yes" (et al), nonzero otherwise.
153 #
154 checkyesno()
155 {
156         eval _value=\$${1}
157         debug "checkyesno: $1 is set to $_value."
158         case $_value in
159
160                 #       "yes", "true", "on", or "1"
161         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
162                 return 0
163                 ;;
164
165                 #       "no", "false", "off", or "0"
166         [Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
167                 return 1
168                 ;;
169         *)
170                 warn "\$${1} is not set properly - see rc.conf(5)."
171                 return 1
172                 ;;
173         esac
174 }
175
176 #
177 # reverse_list list
178 #       print the list in reverse order
179 #
180 reverse_list()
181 {
182         _revlist=
183         for _revfile; do
184                 _revlist="$_revfile $_revlist"
185         done
186         echo $_revlist
187 }
188
189 # stop_boot always
190 #       If booting directly to multiuser or $always is enabled,
191 #       send SIGTERM to the parent (/etc/rc) to abort the boot.
192 #       Otherwise just exit.
193 #
194 stop_boot()
195 {
196         local always
197
198         case $1 in
199                 #       "yes", "true", "on", or "1"
200         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
201                 always=true
202                 ;;
203         *)
204                 always=false
205                 ;;
206         esac
207         if [ "$autoboot" = yes -o "$always" = true ]; then
208                 echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
209                 kill -TERM ${RC_PID}
210         fi
211         exit 1
212 }
213
214 #
215 # mount_critical_filesystems type
216 #       Go through the list of critical filesystems as provided in
217 #       the rc.conf(5) variable $critical_filesystems_${type}, checking
218 #       each one to see if it is mounted, and if it is not, mounting it.
219 #
220 mount_critical_filesystems()
221 {
222         eval _fslist=\$critical_filesystems_${1}
223         for _fs in $_fslist; do
224                 mount | (
225                         _ismounted=false
226                         while read what _on on _type type; do
227                                 if [ $on = $_fs ]; then
228                                         _ismounted=true
229                                 fi
230                         done
231                         if $_ismounted; then
232                                 :
233                         else
234                                 mount $_fs >/dev/null 2>&1
235                         fi
236                 )
237         done
238 }
239
240 #
241 # check_pidfile pidfile procname [interpreter]
242 #       Parses the first line of pidfile for a PID, and ensures
243 #       that the process is running and matches procname.
244 #       Prints the matching PID upon success, nothing otherwise.
245 #       interpreter is optional; see _find_processes() for details.
246 #
247 check_pidfile()
248 {
249         _pidfile=$1
250         _procname=$2
251         _interpreter=$3
252         if [ -z "$_pidfile" -o -z "$_procname" ]; then
253                 err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
254         fi
255         if [ ! -f $_pidfile ]; then
256                 debug "pid file ($_pidfile): not readable."
257                 return
258         fi
259         read _pid _junk < $_pidfile
260         if [ -z "$_pid" ]; then
261                 debug "pid file ($_pidfile): no pid in file."
262                 return
263         fi
264         _find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
265 }
266
267 #
268 # check_process procname [interpreter]
269 #       Ensures that a process (or processes) named procname is running.
270 #       Prints a list of matching PIDs.
271 #       interpreter is optional; see _find_processes() for details.
272 #
273 check_process()
274 {
275         _procname=$1
276         _interpreter=$2
277         if [ -z "$_procname" ]; then
278                 err 3 'USAGE: check_process procname [interpreter]'
279         fi
280         _find_processes $_procname ${_interpreter:-.} '-ax'
281 }
282
283 #
284 # _find_processes procname interpreter psargs
285 #       Search for procname in the output of ps generated by psargs.
286 #       Prints the PIDs of any matching processes, space separated.
287 #
288 #       If interpreter == ".", check the following variations of procname
289 #       against the first word of each command:
290 #               procname
291 #               `basename procname`
292 #               `basename procname` + ":"
293 #               "(" + `basename procname` + ")"
294 #               "[" + `basename procname` + "]"
295 #
296 #       If interpreter != ".", read the first line of procname, remove the
297 #       leading #!, normalise whitespace, append procname, and attempt to
298 #       match that against each command, either as is, or with extra words
299 #       at the end.  As an alternative, to deal with interpreted daemons
300 #       using perl, the basename of the interpreter plus a colon is also
301 #       tried as the prefix to procname.
302 #
303 _find_processes()
304 {
305         if [ $# -ne 3 ]; then
306                 err 3 'USAGE: _find_processes procname interpreter psargs'
307         fi
308         _procname=$1
309         _interpreter=$2
310         _psargs=$3
311
312         _pref=
313         if [ $_interpreter != "." ]; then       # an interpreted script
314                 _script="${_chroot}${_chroot:+/}$_procname"
315                 if [ -r "$_script" ]; then
316                         read _interp < $_script # read interpreter name
317                         case "$_interp" in
318                         \#!*)
319                                 _interp=${_interp#\#!}  # strip #!
320                                 set -- $_interp
321                                 case $1 in
322                                 */bin/env)
323                                         shift   # drop env to get real name
324                                         ;;
325                                 esac
326                                 if [ $_interpreter != $1 ]; then
327                                         warn "\$command_interpreter $_interpreter != $1"
328                                 fi
329                                 ;;
330                         *)
331                                 warn "no shebang line in $_script"
332                                 set -- $_interpreter
333                                 ;;
334                         esac
335                 else
336                         warn "cannot read shebang line from $_script"
337                         set -- $_interpreter
338                 fi
339                 _interp="$* $_procname"         # cleanup spaces, add _procname
340                 _interpbn=${1##*/}
341                 _fp_args='_argv'
342                 _fp_match='case "$_argv" in
343                     ${_interp}|"${_interp} "*|"[${_interpbn}]"|"${_interpbn}: ${_procname}"*)'
344         else                                    # a normal daemon
345                 _procnamebn=${_procname##*/}
346                 _fp_args='_arg0 _argv'
347                 _fp_match='case "$_arg0" in
348                     $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
349         fi
350
351         _proccheck="\
352                 $PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
353                 while read _npid _jid '"$_fp_args"'; do
354                         '"$_fp_match"'
355                                 if [ "$JID" -eq "$_jid" ];
356                                 then echo -n "$_pref$_npid";
357                                 _pref=" ";
358                                 fi
359                                 ;;
360                         esac
361                 done'
362
363 #       debug "in _find_processes: proccheck is ($_proccheck)."
364         eval $_proccheck
365 }
366
367 # sort_lite [-b] [-n] [-k POS] [-t SEP]
368 #       A lite version of sort(1) (supporting a few options) that can be used
369 #       before the real sort(1) is available (e.g., in scripts that run prior
370 #       to mountcritremote). Requires only shell built-in functionality.
371 #
372 sort_lite()
373 {
374         local funcname=sort_lite
375         local sort_sep="$IFS" sort_ignore_leading_space=
376         local sort_field=0 sort_strict_fields= sort_numeric=
377         local nitems=0 skip_leading=0 trim=
378
379         local OPTIND flag
380         while getopts bnk:t: flag; do
381                 case "$flag" in
382                 b) sort_ignore_leading_space=1 ;;
383                 n) sort_numeric=1 sort_ignore_leading_space=1 ;;
384                 k) sort_field="${OPTARG%%,*}" ;; # only up to first comma
385                         # NB: Unlike sort(1) only one POS allowed
386                 t) sort_sep="$OPTARG"
387                    if [ ${#sort_sep} -gt 1 ]; then
388                         echo "$funcname: multi-character tab \`$sort_sep'" >&2
389                         return 1
390                    fi
391                    sort_strict_fields=1
392                    ;;
393                 \?) return 1 ;;
394                 esac
395         done
396         shift $(( $OPTIND - 1 ))
397
398         # Create transformation pattern to trim leading text if desired
399         case "$sort_field" in
400         ""|[!0-9]*|*[!0-9.]*)
401                 echo "$funcname: invalid sort field \`$sort_field'" >&2
402                 return 1
403                 ;;
404         *.*)
405                 skip_leading=${sort_field#*.} sort_field=${sort_field%%.*}
406                 while [ ${skip_leading:-0} -gt 1 ] 2> /dev/null; do
407                         trim="$trim?" skip_leading=$(( $skip_leading - 1 ))
408                 done
409         esac
410
411         # Copy input to series of local numbered variables
412         # NB: IFS of NULL preserves leading whitespace
413         local LINE
414         while IFS= read -r LINE || [ "$LINE" ]; do
415                 nitems=$(( $nitems + 1 ))
416                 local src_$nitems="$LINE"
417         done
418
419         #
420         # Sort numbered locals using insertion sort
421         #
422         local curitem curitem_orig curitem_mod curitem_haskey
423         local dest dest_orig dest_mod dest_haskey
424         local d gt n
425         local i=1 
426         while [ $i -le $nitems ]; do
427                 curitem_haskey=1 # Assume sort field (-k POS) exists
428                 eval curitem=\"\$src_$i\"
429                 curitem_mod="$curitem" # for modified comparison
430                 curitem_orig="$curitem" # for original comparison
431
432                 # Trim leading whitespace if desired
433                 if [ "$sort_ignore_leading_space" ]; then
434                         while case "$curitem_orig" in
435                                 [$IFS]*) : ;; *) false; esac
436                         do
437                                 curitem_orig="${curitem_orig#?}"
438                         done
439                         curitem_mod="$curitem_orig"
440                 fi
441
442                 # Shift modified comparison value if sort field (-k POS) is > 1
443                 n=$sort_field
444                 while [ $n -gt 1 ]; do
445                         case "$curitem_mod" in
446                         *[$sort_sep]*)
447                                 # Cut text up-to (and incl.) first separator
448                                 curitem_mod="${curitem_mod#*[$sort_sep]}"
449
450                                 # Skip NULLs unless strict field splitting
451                                 [ "$sort_strict_fields" ] ||
452                                         [ "${curitem_mod%%[$sort_sep]*}" ] ||
453                                         [ $n -eq 2 ] ||
454                                         continue
455                                 ;;
456                         *)
457                                 # Asked for a field that doesn't exist
458                                 curitem_haskey= break
459                         esac
460                         n=$(( $n - 1 ))
461                 done
462
463                 # Trim trailing words if sort field >= 1
464                 [ $sort_field -ge 1 -a "$sort_numeric" ] &&
465                         curitem_mod="${curitem_mod%%[$sort_sep]*}"
466
467                 # Apply optional trim (-k POS.TRIM) to cut leading characters
468                 curitem_mod="${curitem_mod#$trim}"
469
470                 # Determine the type of modified comparison to use initially
471                 # NB: Prefer numerical if requested but fallback to standard
472                 case "$curitem_mod" in
473                 ""|[!0-9]*) # NULL or begins with non-number
474                         gt=">"
475                         [ "$sort_numeric" ] && curitem_mod=0
476                         ;;
477                 *)
478                         if [ "$sort_numeric" ]; then
479                                 gt="-gt"
480                                 curitem_mod="${curitem_mod%%[!0-9]*}"
481                                         # NB: trailing non-digits removed
482                                         # otherwise numeric comparison fails
483                         else
484                                 gt=">"
485                         fi
486                 esac
487
488                 # If first time through, short-circuit below position-search
489                 if [ $i -le 1 ]; then
490                         d=0
491                 else
492                         d=1
493                 fi
494
495                 #
496                 # Find appropriate element position
497                 #
498                 while [ $d -gt 0 ]
499                 do
500                         dest_haskey=$curitem_haskey
501                         eval dest=\"\$dest_$d\"
502                         dest_mod="$dest" # for modified comparison
503                         dest_orig="$dest" # for original comparison
504
505                         # Trim leading whitespace if desired
506                         if [ "$sort_ignore_leading_space" ]; then
507                                 while case "$dest_orig" in
508                                         [$IFS]*) : ;; *) false; esac
509                                 do
510                                         dest_orig="${dest_orig#?}"
511                                 done
512                                 dest_mod="$dest_orig"
513                         fi
514
515                         # Shift modified value if sort field (-k POS) is > 1
516                         n=$sort_field
517                         while [ $n -gt 1 ]; do
518                                 case "$dest_mod" in
519                                 *[$sort_sep]*)
520                                         # Cut text up-to (and incl.) 1st sep
521                                         dest_mod="${dest_mod#*[$sort_sep]}"
522
523                                         # Skip NULLs unless strict fields
524                                         [ "$sort_strict_fields" ] ||
525                                             [ "${dest_mod%%[$sort_sep]*}" ] ||
526                                             [ $n -eq 2 ] ||
527                                             continue
528                                         ;;
529                                 *)
530                                         # Asked for a field that doesn't exist
531                                         dest_haskey= break
532                                 esac
533                                 n=$(( $n - 1 ))
534                         done
535
536                         # Trim trailing words if sort field >= 1
537                         [ $sort_field -ge 1 -a "$sort_numeric" ] &&
538                                 dest_mod="${dest_mod%%[$sort_sep]*}"
539
540                         # Apply optional trim (-k POS.TRIM), cut leading chars
541                         dest_mod="${dest_mod#$trim}"
542
543                         # Determine type of modified comparison to use
544                         # NB: Prefer numerical if requested, fallback to std
545                         case "$dest_mod" in
546                         ""|[!0-9]*) # NULL or begins with non-number
547                                 gt=">"
548                                 [ "$sort_numeric" ] && dest_mod=0
549                                 ;;
550                         *)
551                                 if [ "$sort_numeric" ]; then
552                                         gt="-gt"
553                                         dest_mod="${dest_mod%%[!0-9]*}"
554                                                 # NB: kill trailing non-digits
555                                                 # for numeric comparison safety
556                                 else
557                                         gt=">"
558                                 fi
559                         esac
560
561                         # Break if we've found the proper element position
562                         if [ "$curitem_haskey" -a "$dest_haskey" ]; then
563                                 if [ "$dest_mod" = "$curitem_mod" ]; then
564                                         [ "$dest_orig" ">" "$curitem_orig" ] &&
565                                                 break
566                                 elif [ "$dest_mod" $gt "$curitem_mod" ] \
567                                         2> /dev/null
568                                 then
569                                         break
570                                 fi
571                         else
572                                 [ "$dest_orig" ">" "$curitem_orig" ] && break
573                         fi
574
575                         # Break if we've hit the end
576                         [ $d -ge $i ] && break
577
578                         d=$(( $d + 1 ))
579                 done
580
581                 # Shift remaining positions forward, making room for new item
582                 n=$i
583                 while [ $n -ge $d ]; do
584                         # Shift destination item forward one placement
585                         eval dest_$(( $n + 1 ))=\"\$dest_$n\"
586                         n=$(( $n - 1 ))
587                 done
588
589                 # Place the element
590                 if [ $i -eq 1 ]; then
591                         local dest_1="$curitem"
592                 else
593                         local dest_$d="$curitem"
594                 fi
595
596                 i=$(( $i + 1 ))
597         done
598
599         # Print sorted results
600         d=1
601         while [ $d -le $nitems ]; do
602                 eval echo \"\$dest_$d\"
603                 d=$(( $d + 1 ))
604         done
605 }
606
607 #
608 # wait_for_pids pid [pid ...]
609 #       spins until none of the pids exist
610 #
611 wait_for_pids()
612 {
613         local _list _prefix _nlist _j
614
615         _list="$@"
616         if [ -z "$_list" ]; then
617                 return
618         fi
619         _prefix=
620         while true; do
621                 _nlist="";
622                 for _j in $_list; do
623                         if kill -0 $_j 2>/dev/null; then
624                                 _nlist="${_nlist}${_nlist:+ }$_j"
625                                 [ -n "$_prefix" ] && sleep 1
626                         fi
627                 done
628                 if [ -z "$_nlist" ]; then
629                         break
630                 fi
631                 _list=$_nlist
632                 echo -n ${_prefix:-"Waiting for PIDS: "}$_list
633                 _prefix=", "
634                 pwait $_list 2>/dev/null
635         done
636         if [ -n "$_prefix" ]; then
637                 echo "."
638         fi
639 }
640
641 #
642 # get_pidfile_from_conf string file
643 #
644 #       Takes a string to search for in the specified file.
645 #       Ignores lines with traditional comment characters.
646 #
647 # Example:
648 #
649 # if get_pidfile_from_conf string file; then
650 #       pidfile="$_pidfile_from_conf"
651 # else
652 #       pidfile='appropriate default'
653 # fi
654 #
655 get_pidfile_from_conf()
656 {
657         if [ -z "$1" -o -z "$2" ]; then
658                 err 3 "USAGE: get_pidfile_from_conf string file ($name)"
659         fi
660
661         local string file line
662
663         string="$1" ; file="$2"
664
665         if [ ! -s "$file" ]; then
666                 err 3 "get_pidfile_from_conf: $file does not exist ($name)"
667         fi
668
669         while read line; do
670                 case "$line" in
671                 *[#\;]*${string}*)      continue ;;
672                 *${string}*)            break ;;
673                 esac
674         done < $file
675
676         if [ -n "$line" ]; then
677                 line=${line#*/}
678                 _pidfile_from_conf="/${line%%[\"\;]*}"
679         else
680                 return 1
681         fi
682 }
683
684 #
685 # check_startmsgs
686 #       If rc_quiet is set (usually as a result of using faststart at
687 #       boot time) check if rc_startmsgs is enabled.
688 #
689 check_startmsgs()
690 {
691         if [ -n "$rc_quiet" ]; then
692                 checkyesno rc_startmsgs
693         else
694                 return 0
695         fi
696 }
697
698 #
699 # run_rc_command argument
700 #       Search for argument in the list of supported commands, which is:
701 #               "start stop restart rcvar status poll ${extra_commands}"
702 #       If there's a match, run ${argument}_cmd or the default method
703 #       (see below).
704 #
705 #       If argument has a given prefix, then change the operation as follows:
706 #               Prefix  Operation
707 #               ------  ---------
708 #               fast    Skip the pid check, and set rc_fast=yes, rc_quiet=yes
709 #               force   Set ${rcvar} to YES, and set rc_force=yes
710 #               one     Set ${rcvar} to YES
711 #               quiet   Don't output some diagnostics, and set rc_quiet=yes
712 #
713 #       The following globals are used:
714 #
715 #       Name            Needed  Purpose
716 #       ----            ------  -------
717 #       name            y       Name of script.
718 #
719 #       command         n       Full path to command.
720 #                               Not needed if ${rc_arg}_cmd is set for
721 #                               each keyword.
722 #
723 #       command_args    n       Optional args/shell directives for command.
724 #
725 #       command_interpreter n   If not empty, command is interpreted, so
726 #                               call check_{pidfile,process}() appropriately.
727 #
728 #       desc            n       Description of script.
729 #
730 #       extra_commands  n       List of extra commands supported.
731 #
732 #       pidfile         n       If set, use check_pidfile $pidfile $command,
733 #                               otherwise use check_process $command.
734 #                               In either case, only check if $command is set.
735 #
736 #       procname        n       Process name to check for instead of $command.
737 #
738 #       rcvar           n       This is checked with checkyesno to determine
739 #                               if the action should be run.
740 #
741 #       ${name}_program n       Full path to command.
742 #                               Meant to be used in /etc/rc.conf to override
743 #                               ${command}.
744 #
745 #       ${name}_chroot  n       Directory to chroot to before running ${command}
746 #                               Requires /usr to be mounted.
747 #
748 #       ${name}_chdir   n       Directory to cd to before running ${command}
749 #                               (if not using ${name}_chroot).
750 #
751 #       ${name}_flags   n       Arguments to call ${command} with.
752 #                               NOTE:   $flags from the parent environment
753 #                                       can be used to override this.
754 #
755 #       ${name}_env     n       Environment variables to run ${command} with.
756 #
757 #       ${name}_fib     n       Routing table number to run ${command} with.
758 #
759 #       ${name}_nice    n       Nice level to run ${command} at.
760 #
761 #       ${name}_oomprotect n    Don't kill ${command} when swap space is exhausted.
762 #
763 #       ${name}_user    n       User to run ${command} as, using su(1) if not
764 #                               using ${name}_chroot.
765 #                               Requires /usr to be mounted.
766 #
767 #       ${name}_group   n       Group to run chrooted ${command} as.
768 #                               Requires /usr to be mounted.
769 #
770 #       ${name}_groups  n       Comma separated list of supplementary groups
771 #                               to run the chrooted ${command} with.
772 #                               Requires /usr to be mounted.
773 #
774 #       ${name}_prepend n       Command added before ${command}.
775 #
776 #       ${name}_login_class n   Login class to use, else "daemon".
777 #
778 #       ${name}_limits  n       limits(1) to apply to ${command}.
779 #
780 #       ${rc_arg}_cmd   n       If set, use this as the method when invoked;
781 #                               Otherwise, use default command (see below)
782 #
783 #       ${rc_arg}_precmd n      If set, run just before performing the
784 #                               ${rc_arg}_cmd method in the default
785 #                               operation (i.e, after checking for required
786 #                               bits and process (non)existence).
787 #                               If this completes with a non-zero exit code,
788 #                               don't run ${rc_arg}_cmd.
789 #
790 #       ${rc_arg}_postcmd n     If set, run just after performing the
791 #                               ${rc_arg}_cmd method, if that method
792 #                               returned a zero exit code.
793 #
794 #       required_dirs   n       If set, check for the existence of the given
795 #                               directories before running a (re)start command.
796 #
797 #       required_files  n       If set, check for the readability of the given
798 #                               files before running a (re)start command.
799 #
800 #       required_modules n      If set, ensure the given kernel modules are
801 #                               loaded before running a (re)start command.
802 #                               The check and possible loads are actually
803 #                               done after start_precmd so that the modules
804 #                               aren't loaded in vain, should the precmd
805 #                               return a non-zero status to indicate a error.
806 #                               If a word in the list looks like "foo:bar",
807 #                               "foo" is the KLD file name and "bar" is the
808 #                               module name.  If a word looks like "foo~bar",
809 #                               "foo" is the KLD file name and "bar" is a
810 #                               egrep(1) pattern matching the module name.
811 #                               Otherwise the module name is assumed to be
812 #                               the same as the KLD file name, which is most
813 #                               common.  See load_kld().
814 #
815 #       required_vars   n       If set, perform checkyesno on each of the
816 #                               listed variables before running the default
817 #                               (re)start command.
818 #
819 #       Default behaviour for a given argument, if no override method is
820 #       provided:
821 #
822 #       Argument        Default behaviour
823 #       --------        -----------------
824 #       start           if !running && checkyesno ${rcvar}
825 #                               ${command}
826 #
827 #       stop            if ${pidfile}
828 #                               rc_pid=$(check_pidfile $pidfile $command)
829 #                       else
830 #                               rc_pid=$(check_process $command)
831 #                       kill $sig_stop $rc_pid
832 #                       wait_for_pids $rc_pid
833 #                       ($sig_stop defaults to TERM.)
834 #
835 #       reload          Similar to stop, except use $sig_reload instead,
836 #                       and doesn't wait_for_pids.
837 #                       $sig_reload defaults to HUP.
838 #                       Note that `reload' isn't provided by default,
839 #                       it should be enabled via $extra_commands.
840 #
841 #       restart         Run `stop' then `start'.
842 #
843 #       status          Show if ${command} is running, etc.
844 #
845 #       poll            Wait for ${command} to exit.
846 #
847 #       rcvar           Display what rc.conf variable is used (if any).
848 #
849 #       enabled         Return true if the service is enabled.
850 #
851 #       describe        Show the service's description
852 #
853 #       extracommands   Show the service's extra commands
854 #
855 #       Variables available to methods, and after run_rc_command() has
856 #       completed:
857 #
858 #       Variable        Purpose
859 #       --------        -------
860 #       rc_arg          Argument to command, after fast/force/one processing
861 #                       performed
862 #
863 #       rc_flags        Flags to start the default command with.
864 #                       Defaults to ${name}_flags, unless overridden
865 #                       by $flags from the environment.
866 #                       This variable may be changed by the precmd method.
867 #
868 #       rc_pid          PID of command (if appropriate)
869 #
870 #       rc_fast         Not empty if "fast" was provided (q.v.)
871 #
872 #       rc_force        Not empty if "force" was provided (q.v.)
873 #
874 #       rc_quiet        Not empty if "quiet" was provided
875 #
876 #
877 run_rc_command()
878 {
879         _return=0
880         rc_arg=$1
881         if [ -z "$name" ]; then
882                 err 3 'run_rc_command: $name is not set.'
883         fi
884
885         # Don't repeat the first argument when passing additional command-
886         # line arguments to the command subroutines.
887         #
888         shift 1
889         rc_extra_args="$*"
890
891         _rc_prefix=
892         case "$rc_arg" in
893         fast*)                          # "fast" prefix; don't check pid
894                 rc_arg=${rc_arg#fast}
895                 rc_fast=yes
896                 rc_quiet=yes
897                 ;;
898         force*)                         # "force" prefix; always run
899                 rc_force=yes
900                 _rc_prefix=force
901                 rc_arg=${rc_arg#${_rc_prefix}}
902                 if [ -n "${rcvar}" ]; then
903                         eval ${rcvar}=YES
904                 fi
905                 ;;
906         one*)                           # "one" prefix; set ${rcvar}=yes
907                 _rc_prefix=one
908                 rc_arg=${rc_arg#${_rc_prefix}}
909                 if [ -n "${rcvar}" ]; then
910                         eval ${rcvar}=YES
911                 fi
912                 ;;
913         quiet*)                         # "quiet" prefix; omit some messages
914                 _rc_prefix=quiet
915                 rc_arg=${rc_arg#${_rc_prefix}}
916                 rc_quiet=yes
917                 ;;
918         esac
919
920         eval _override_command=\$${name}_program
921         command=${_override_command:-$command}
922
923         _keywords="start stop restart rcvar enabled describe extracommands $extra_commands"
924         rc_pid=
925         _pidcmd=
926         _procname=${procname:-${command}}
927
928                                         # setup pid check command
929         if [ -n "$_procname" ]; then
930                 if [ -n "$pidfile" ]; then
931                         _pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
932                 else
933                         _pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
934                 fi
935                 _keywords="${_keywords} status poll"
936         fi
937
938         if [ -z "$rc_arg" ]; then
939                 rc_usage $_keywords
940         fi
941
942         if [ "$rc_arg" = "enabled" ] ; then
943                 checkyesno ${rcvar}
944                 return $?
945         fi
946
947         if [ -n "$flags" ]; then        # allow override from environment
948                 rc_flags=$flags
949         else
950                 eval rc_flags=\$${name}_flags
951         fi
952         eval _chdir=\$${name}_chdir     _chroot=\$${name}_chroot \
953             _nice=\$${name}_nice        _user=\$${name}_user \
954             _group=\$${name}_group      _groups=\$${name}_groups \
955             _fib=\$${name}_fib          _env=\$${name}_env \
956             _prepend=\$${name}_prepend  _login_class=\${${name}_login_class:-daemon} \
957             _limits=\$${name}_limits    _oomprotect=\$${name}_oomprotect
958
959         if [ -n "$_user" ]; then        # unset $_user if running as that user
960                 if [ "$_user" = "$(eval $IDCMD)" ]; then
961                         unset _user
962                 fi
963         fi
964
965         [ -z "$autoboot" ] && eval $_pidcmd     # determine the pid if necessary
966
967         for _elem in $_keywords; do
968                 if [ "$_elem" != "$rc_arg" ]; then
969                         continue
970                 fi
971                                         # if ${rcvar} is set, $1 is not "rcvar" and not "describe"
972                                         # and ${rc_pid} is not set, then run
973                                         #       checkyesno ${rcvar}
974                                         # and return if that failed
975                                         #
976                 if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" -a "$rc_arg" != "stop" \
977                     -a "$rc_arg" != "describe" ] ||
978                     [ -n "${rcvar}" -a "$rc_arg" = "stop" -a -z "${rc_pid}" ]; then
979                         if ! checkyesno ${rcvar}; then
980                                 if [ -n "${rc_quiet}" ]; then
981                                         return 0
982                                 fi
983                                 echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
984                                 echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
985                                 echo "instead of '${rc_arg}'."
986                                 return 0
987                         fi
988                 fi
989
990                 if [ $rc_arg = "start" -a -z "$rc_fast" -a -n "$rc_pid" ]; then
991                         if [ -z "$rc_quiet" ]; then
992                                 echo 1>&2 "${name} already running? " \
993                                     "(pid=$rc_pid)."
994                         fi
995                         return 1
996                 fi
997
998                                         # if there's a custom ${XXX_cmd},
999                                         # run that instead of the default
1000                                         #
1001                 eval _cmd=\$${rc_arg}_cmd \
1002                      _precmd=\$${rc_arg}_precmd \
1003                      _postcmd=\$${rc_arg}_postcmd
1004
1005                 if [ -n "$_cmd" ]; then
1006                         _run_rc_precmd || return 1
1007                         _run_rc_doit "$_cmd $rc_extra_args" || return 1
1008                         _run_rc_postcmd
1009                         return $_return
1010                 fi
1011
1012                 case "$rc_arg" in       # default operations...
1013
1014                 describe)
1015                         if [ -n "$desc" ]; then
1016                                 echo "$desc"
1017                         fi
1018                         ;;
1019         
1020                 extracommands)
1021                         echo "$extra_commands"
1022                         ;;
1023
1024                 status)
1025                         _run_rc_precmd || return 1
1026                         if [ -n "$rc_pid" ]; then
1027                                 echo "${name} is running as pid $rc_pid."
1028                         else
1029                                 echo "${name} is not running."
1030                                 return 1
1031                         fi
1032                         _run_rc_postcmd
1033                         ;;
1034
1035                 start)
1036                         if [ ! -x "${_chroot}${_chroot:+/}${command}" ]; then
1037                                 warn "run_rc_command: cannot run $command"
1038                                 return 1
1039                         fi
1040
1041                         if ! _run_rc_precmd; then
1042                                 warn "failed precmd routine for ${name}"
1043                                 return 1
1044                         fi
1045
1046                                         # setup the full command to run
1047                                         #
1048                         check_startmsgs && echo "Starting ${name}."
1049                         if [ -n "$_chroot" ]; then
1050                                 _cd=
1051                                 _doit="\
1052 ${_nice:+nice -n $_nice }\
1053 ${_fib:+setfib -F $_fib }\
1054 ${_env:+env $_env }\
1055 chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
1056 $_chroot $command $rc_flags $command_args"
1057                         else
1058                                 _cd="${_chdir:+cd $_chdir && }"
1059                                 _doit="\
1060 ${_fib:+setfib -F $_fib }\
1061 ${_env:+env $_env }\
1062 $command $rc_flags $command_args"
1063                                 if [ -n "$_user" ]; then
1064                                     _doit="su -m $_user -c 'sh -c \"$_doit\"'"
1065                                 fi
1066                                 if [ -n "$_nice" ]; then
1067                                         if [ -z "$_user" ]; then
1068                                                 _doit="sh -c \"$_doit\""
1069                                         fi
1070                                         _doit="nice -n $_nice $_doit"
1071                                 fi
1072                                 if [ -n "$_prepend" ]; then
1073                                         _doit="$_prepend $_doit"
1074                                 fi
1075                         fi
1076
1077                                         # Prepend default limits
1078                         _doit="$_cd limits -C $_login_class $_limits $_doit"
1079
1080                                         # run the full command
1081                                         #
1082                         if ! _run_rc_doit "$_doit"; then
1083                                 warn "failed to start ${name}"
1084                                 return 1
1085                         fi
1086
1087                                         # finally, run postcmd
1088                                         #
1089                         _run_rc_postcmd
1090                         ;;
1091
1092                 stop)
1093                         if [ -z "$rc_pid" ]; then
1094                                 [ -n "$rc_fast" ] && return 0
1095                                 _run_rc_notrunning
1096                                 return 1
1097                         fi
1098
1099                         _run_rc_precmd || return 1
1100
1101                                         # send the signal to stop
1102                                         #
1103                         echo "Stopping ${name}."
1104                         _doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
1105                         _run_rc_doit "$_doit" || return 1
1106
1107                                         # wait for the command to exit,
1108                                         # and run postcmd.
1109                         wait_for_pids $rc_pid
1110
1111                         _run_rc_postcmd
1112                         ;;
1113
1114                 reload)
1115                         if [ -z "$rc_pid" ]; then
1116                                 _run_rc_notrunning
1117                                 return 1
1118                         fi
1119
1120                         _run_rc_precmd || return 1
1121
1122                         _doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
1123                         _run_rc_doit "$_doit" || return 1
1124
1125                         _run_rc_postcmd
1126                         ;;
1127
1128                 restart)
1129                                         # prevent restart being called more
1130                                         # than once by any given script
1131                                         #
1132                         if ${_rc_restart_done:-false}; then
1133                                 return 0
1134                         fi
1135                         _rc_restart_done=true
1136
1137                         _run_rc_precmd || return 1
1138
1139                         # run those in a subshell to keep global variables
1140                         ( run_rc_command ${_rc_prefix}stop $rc_extra_args )
1141                         ( run_rc_command ${_rc_prefix}start $rc_extra_args )
1142                         _return=$?
1143                         [ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
1144
1145                         _run_rc_postcmd
1146                         ;;
1147
1148                 poll)
1149                         _run_rc_precmd || return 1
1150                         if [ -n "$rc_pid" ]; then
1151                                 wait_for_pids $rc_pid
1152                         fi
1153                         _run_rc_postcmd
1154                         ;;
1155
1156                 rcvar)
1157                         echo -n "# $name"
1158                         if [ -n "$desc" ]; then
1159                                 echo " : $desc"
1160                         else
1161                                 echo ""
1162                         fi
1163                         echo "#"
1164                         # Get unique vars in $rcvar $rcvars
1165                         for _v in $rcvar $rcvars; do
1166                                 case $v in
1167                                 $_v\ *|\ *$_v|*\ $_v\ *) ;;
1168                                 *)      v="${v# } $_v" ;;
1169                                 esac
1170                         done
1171
1172                         # Display variables.
1173                         for _v in $v; do
1174                                 if [ -z "$_v" ]; then
1175                                         continue
1176                                 fi
1177
1178                                 eval _desc=\$${_v}_desc
1179                                 eval _defval=\$${_v}_defval
1180                                 _h="-"
1181
1182                                 eval echo \"$_v=\\\"\$$_v\\\"\"
1183                                 # decode multiple lines of _desc
1184                                 while [ -n "$_desc" ]; do
1185                                         case $_desc in
1186                                         *^^*)
1187                                                 echo "# $_h ${_desc%%^^*}"
1188                                                 _desc=${_desc#*^^}
1189                                                 _h=" "
1190                                                 ;;
1191                                         *)
1192                                                 echo "# $_h ${_desc}"
1193                                                 break
1194                                                 ;;
1195                                         esac
1196                                 done
1197                                 echo "#   (default: \"$_defval\")"
1198                         done
1199                         echo ""
1200                         ;;
1201
1202                 *)
1203                         rc_usage $_keywords
1204                         ;;
1205
1206                 esac
1207
1208                 # Apply protect(1) to the PID if ${name}_oomprotect is set.
1209                 case "$rc_arg" in
1210                 start)
1211                         # We cannot use protect(1) inside jails.
1212                         if [ -n "$_oomprotect" ] && [ -f "${PROTECT}" ] &&
1213                             [ "$(sysctl -n security.jail.jailed)" -eq 0 ]; then
1214                                 pid=$(check_process $command)
1215                                 case $_oomprotect in
1216                                 [Aa][Ll][Ll])
1217                                         ${PROTECT} -i -p ${pid}
1218                                         ;;
1219                                 [Yy][Ee][Ss])
1220                                         ${PROTECT} -p ${pid}
1221                                         ;;
1222                                 esac
1223                         fi      
1224                 ;;
1225                 esac
1226
1227                 return $_return
1228         done
1229
1230         echo 1>&2 "$0: unknown directive '$rc_arg'."
1231         rc_usage $_keywords
1232         # not reached
1233 }
1234
1235 #
1236 # Helper functions for run_rc_command: common code.
1237 # They use such global variables besides the exported rc_* ones:
1238 #
1239 #       name           R/W
1240 #       ------------------
1241 #       _precmd         R
1242 #       _postcmd        R
1243 #       _return         W
1244 #
1245 _run_rc_precmd()
1246 {
1247         check_required_before "$rc_arg" || return 1
1248
1249         if [ -n "$_precmd" ]; then
1250                 debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
1251                 eval "$_precmd $rc_extra_args"
1252                 _return=$?
1253
1254                 # If precmd failed and force isn't set, request exit.
1255                 if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1256                         return 1
1257                 fi
1258         fi
1259
1260         check_required_after "$rc_arg" || return 1
1261
1262         return 0
1263 }
1264
1265 _run_rc_postcmd()
1266 {
1267         if [ -n "$_postcmd" ]; then
1268                 debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
1269                 eval "$_postcmd $rc_extra_args"
1270                 _return=$?
1271         fi
1272         return 0
1273 }
1274
1275 _run_rc_doit()
1276 {
1277         debug "run_rc_command: doit: $*"
1278         eval "$@"
1279         _return=$?
1280
1281         # If command failed and force isn't set, request exit.
1282         if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1283                 return 1
1284         fi
1285
1286         return 0
1287 }
1288
1289 _run_rc_notrunning()
1290 {
1291         local _pidmsg
1292
1293         if [ -n "$pidfile" ]; then
1294                 _pidmsg=" (check $pidfile)."
1295         else
1296                 _pidmsg=
1297         fi
1298         echo 1>&2 "${name} not running?${_pidmsg}"
1299 }
1300
1301 _run_rc_killcmd()
1302 {
1303         local _cmd
1304
1305         _cmd="kill -$1 $rc_pid"
1306         if [ -n "$_user" ]; then
1307                 _cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
1308         fi
1309         echo "$_cmd"
1310 }
1311
1312 #
1313 # run_rc_script file arg
1314 #       Start the script `file' with `arg', and correctly handle the
1315 #       return value from the script.
1316 #       If `file' ends with `.sh' and lives in /etc/rc.d, ignore it as it's
1317 #       an old-style startup file.
1318 #       If `file' ends with `.sh' and does not live in /etc/rc.d, it's sourced
1319 #       into the current environment if $rc_fast_and_loose is set; otherwise
1320 #       it is run as a child process.
1321 #       If `file' appears to be a backup or scratch file, ignore it.
1322 #       Otherwise if it is executable run as a child process.
1323 #
1324 run_rc_script()
1325 {
1326         _file=$1
1327         _arg=$2
1328         if [ -z "$_file" -o -z "$_arg" ]; then
1329                 err 3 'USAGE: run_rc_script file arg'
1330         fi
1331
1332         unset   name command command_args command_interpreter \
1333                 extra_commands pidfile procname \
1334                 rcvar rcvars rcvars_obsolete required_dirs required_files \
1335                 required_vars
1336         eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
1337
1338         case "$_file" in
1339         /etc/rc.d/*.sh)                 # no longer allowed in the base
1340                 warn "Ignoring old-style startup script $_file"
1341                 ;;
1342         *[~#]|*.OLD|*.bak|*.orig|*,v)   # scratch file; skip
1343                 warn "Ignoring scratch file $_file"
1344                 ;;
1345         *)                              # run in subshell
1346                 if [ -x $_file ]; then
1347                         if [ -n "$rc_fast_and_loose" ]; then
1348                                 set $_arg; . $_file
1349                         else
1350                                 ( trap "echo Script $_file interrupted >&2 ; kill -QUIT $$" 3
1351                                   trap "echo Script $_file interrupted >&2 ; exit 1" 2
1352                                   trap "echo Script $_file running >&2" 29
1353                                   set $_arg; . $_file )
1354                         fi
1355                 fi
1356                 ;;
1357         esac
1358 }
1359
1360 #
1361 # load_rc_config [service]
1362 #       Source in the configuration file(s) for a given service.
1363 #       If no service is specified, only the global configuration
1364 #       file(s) will be loaded.
1365 #
1366 load_rc_config()
1367 {
1368         local _name _rcvar_val _var _defval _v _msg _new _d
1369         _name=$1
1370
1371         if ${_rc_conf_loaded:-false}; then
1372                 :
1373         else
1374                 if [ -r /etc/defaults/rc.conf ]; then
1375                         debug "Sourcing /etc/defaults/rc.conf"
1376                         . /etc/defaults/rc.conf
1377                         source_rc_confs
1378                 elif [ -r /etc/rc.conf ]; then
1379                         debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
1380                         . /etc/rc.conf
1381                 fi
1382                 _rc_conf_loaded=true
1383         fi
1384
1385         # If a service name was specified, attempt to load
1386         # service-specific configuration
1387         if [ -n "$_name" ] ; then
1388                 for _d in /etc ${local_startup}; do
1389                         _d=${_d%/rc.d}
1390                         if [ -f ${_d}/rc.conf.d/"$_name" ]; then
1391                                 debug "Sourcing ${_d}/rc.conf.d/$_name"
1392                                 . ${_d}/rc.conf.d/"$_name"
1393                         elif [ -d ${_d}/rc.conf.d/"$_name" ] ; then
1394                                 local _rc
1395                                 for _rc in ${_d}/rc.conf.d/"$_name"/* ; do
1396                                         if [ -f "$_rc" ] ; then
1397                                                 debug "Sourcing $_rc"
1398                                                 . "$_rc"
1399                                         fi
1400                                 done
1401                         fi
1402                 done
1403         fi
1404
1405         # Set defaults if defined.
1406         for _var in $rcvar $rcvars; do
1407                 eval _defval=\$${_var}_defval
1408                 if [ -n "$_defval" ]; then
1409                         eval : \${$_var:=\$${_var}_defval}
1410                 fi
1411         done
1412
1413         # check obsolete rc.conf variables
1414         for _var in $rcvars_obsolete; do
1415                 eval _v=\$$_var
1416                 eval _msg=\$${_var}_obsolete_msg
1417                 eval _new=\$${_var}_newvar
1418                 case $_v in
1419                 "")
1420                         ;;
1421                 *)
1422                         if [ -z "$_new" ]; then
1423                                 _msg="Ignored."
1424                         else
1425                                 eval $_new=\"\$$_var\"
1426                                 if [ -z "$_msg" ]; then
1427                                         _msg="Use \$$_new instead."
1428                                 fi
1429                         fi
1430                         warn "\$$_var is obsolete.  $_msg"
1431                         ;;
1432                 esac
1433         done
1434 }
1435
1436 #
1437 # load_rc_config_var name var
1438 #       Read the rc.conf(5) var for name and set in the
1439 #       current shell, using load_rc_config in a subshell to prevent
1440 #       unwanted side effects from other variable assignments.
1441 #
1442 load_rc_config_var()
1443 {
1444         if [ $# -ne 2 ]; then
1445                 err 3 'USAGE: load_rc_config_var name var'
1446         fi
1447         eval $(eval '(
1448                 load_rc_config '$1' >/dev/null;
1449                 if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
1450                         echo '$2'=\'\''${'$2'}\'\'';
1451                 fi
1452         )' )
1453 }
1454
1455 #
1456 # rc_usage commands
1457 #       Print a usage string for $0, with `commands' being a list of
1458 #       valid commands.
1459 #
1460 rc_usage()
1461 {
1462         echo -n 1>&2 "Usage: $0 [fast|force|one|quiet]("
1463
1464         _sep=
1465         for _elem; do
1466                 echo -n 1>&2 "$_sep$_elem"
1467                 _sep="|"
1468         done
1469         echo 1>&2 ")"
1470         exit 1
1471 }
1472
1473 #
1474 # err exitval message
1475 #       Display message to stderr and log to the syslog, and exit with exitval.
1476 #
1477 err()
1478 {
1479         exitval=$1
1480         shift
1481
1482         if [ -x /usr/bin/logger ]; then
1483                 logger "$0: ERROR: $*"
1484         fi
1485         echo 1>&2 "$0: ERROR: $*"
1486         exit $exitval
1487 }
1488
1489 #
1490 # warn message
1491 #       Display message to stderr and log to the syslog.
1492 #
1493 warn()
1494 {
1495         if [ -x /usr/bin/logger ]; then
1496                 logger "$0: WARNING: $*"
1497         fi
1498         echo 1>&2 "$0: WARNING: $*"
1499 }
1500
1501 #
1502 # info message
1503 #       Display informational message to stdout and log to syslog.
1504 #
1505 info()
1506 {
1507         case ${rc_info} in
1508         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1509                 if [ -x /usr/bin/logger ]; then
1510                         logger "$0: INFO: $*"
1511                 fi
1512                 echo "$0: INFO: $*"
1513                 ;;
1514         esac
1515 }
1516
1517 #
1518 # debug message
1519 #       If debugging is enabled in rc.conf output message to stderr.
1520 #       BEWARE that you don't call any subroutine that itself calls this
1521 #       function.
1522 #
1523 debug()
1524 {
1525         case ${rc_debug} in
1526         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1527                 if [ -x /usr/bin/logger ]; then
1528                         logger "$0: DEBUG: $*"
1529                 fi
1530                 echo 1>&2 "$0: DEBUG: $*"
1531                 ;;
1532         esac
1533 }
1534
1535 #
1536 # backup_file action file cur backup
1537 #       Make a backup copy of `file' into `cur', and save the previous
1538 #       version of `cur' as `backup'.
1539 #
1540 #       The `action' keyword can be one of the following:
1541 #
1542 #       add             `file' is now being backed up (and is possibly
1543 #                       being reentered into the backups system).  `cur'
1544 #                       is created.
1545 #
1546 #       update          `file' has changed and needs to be backed up.
1547 #                       If `cur' exists, it is copied to `back'
1548 #                       and then `file' is copied to `cur'.
1549 #
1550 #       remove          `file' is no longer being tracked by the backups
1551 #                       system.  `cur' is moved `back'.
1552 #
1553 #
1554 backup_file()
1555 {
1556         _action=$1
1557         _file=$2
1558         _cur=$3
1559         _back=$4
1560
1561         case $_action in
1562         add|update)
1563                 if [ -f $_cur ]; then
1564                         cp -p $_cur $_back
1565                 fi
1566                 cp -p $_file $_cur
1567                 chown root:wheel $_cur
1568                 ;;
1569         remove)
1570                 mv -f $_cur $_back
1571                 ;;
1572         esac
1573 }
1574
1575 # make_symlink src link
1576 #       Make a symbolic link 'link' to src from basedir. If the
1577 #       directory in which link is to be created does not exist
1578 #       a warning will be displayed and an error will be returned.
1579 #       Returns 0 on success, 1 otherwise.
1580 #
1581 make_symlink()
1582 {
1583         local src link linkdir _me
1584         src="$1"
1585         link="$2"
1586         linkdir="`dirname $link`"
1587         _me="make_symlink()"
1588
1589         if [ -z "$src" -o -z "$link" ]; then
1590                 warn "$_me: requires two arguments."
1591                 return 1
1592         fi
1593         if [ ! -d "$linkdir" ]; then
1594                 warn "$_me: the directory $linkdir does not exist."
1595                 return 1
1596         fi
1597         if ! ln -sf $src $link; then
1598                 warn "$_me: unable to make a symbolic link from $link to $src"
1599                 return 1
1600         fi
1601         return 0
1602 }
1603
1604 # devfs_rulesets_from_file file
1605 #       Reads a set of devfs commands from file, and creates
1606 #       the specified rulesets with their rules. Returns non-zero
1607 #       if there was an error.
1608 #
1609 devfs_rulesets_from_file()
1610 {
1611         local file _err _me _opts
1612         file="$1"
1613         _me="devfs_rulesets_from_file"
1614         _err=0
1615
1616         if [ -z "$file" ]; then
1617                 warn "$_me: you must specify a file"
1618                 return 1
1619         fi
1620         if [ ! -e "$file" ]; then
1621                 debug "$_me: no such file ($file)"
1622                 return 0
1623         fi
1624
1625         # Disable globbing so that the rule patterns are not expanded
1626         # by accident with matching filesystem entries.
1627         _opts=$-; set -f
1628
1629         debug "reading rulesets from file ($file)"
1630         { while read line
1631         do
1632                 case $line in
1633                 \#*)
1634                         continue
1635                         ;;
1636                 \[*\]*)
1637                         rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1638                         if [ -z "$rulenum" ]; then
1639                                 warn "$_me: cannot extract rule number ($line)"
1640                                 _err=1
1641                                 break
1642                         fi
1643                         rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1644                         if [ -z "$rulename" ]; then
1645                                 warn "$_me: cannot extract rule name ($line)"
1646                                 _err=1
1647                                 break;
1648                         fi
1649                         eval $rulename=\$rulenum
1650                         debug "found ruleset: $rulename=$rulenum"
1651                         if ! /sbin/devfs rule -s $rulenum delset; then
1652                                 _err=1
1653                                 break
1654                         fi
1655                         ;;
1656                 *)
1657                         rulecmd="${line%%"\#*"}"
1658                         # evaluate the command incase it includes
1659                         # other rules
1660                         if [ -n "$rulecmd" ]; then
1661                                 debug "adding rule ($rulecmd)"
1662                                 if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1663                                 then
1664                                         _err=1
1665                                         break
1666                                 fi
1667                         fi
1668                         ;;
1669                 esac
1670                 if [ $_err -ne 0 ]; then
1671                         debug "error in $_me"
1672                         break
1673                 fi
1674         done } < $file
1675         case $_opts in *f*) ;; *) set +f ;; esac
1676         return $_err
1677 }
1678
1679 # devfs_init_rulesets
1680 #       Initializes rulesets from configuration files. Returns
1681 #       non-zero if there was an error.
1682 #
1683 devfs_init_rulesets()
1684 {
1685         local file _me
1686         _me="devfs_init_rulesets"
1687
1688         # Go through this only once
1689         if [ -n "$devfs_rulesets_init" ]; then
1690                 debug "$_me: devfs rulesets already initialized"
1691                 return
1692         fi
1693         for file in $devfs_rulesets; do
1694                 if ! devfs_rulesets_from_file $file; then
1695                         warn "$_me: could not read rules from $file"
1696                         return 1
1697                 fi
1698         done
1699         devfs_rulesets_init=1
1700         debug "$_me: devfs rulesets initialized"
1701         return 0
1702 }
1703
1704 # devfs_set_ruleset ruleset [dir]
1705 #       Sets the default ruleset of dir to ruleset. The ruleset argument
1706 #       must be a ruleset name as specified in devfs.rules(5) file.
1707 #       Returns non-zero if it could not set it successfully.
1708 #
1709 devfs_set_ruleset()
1710 {
1711         local devdir rs _me
1712         [ -n "$1" ] && eval rs=\$$1 || rs=
1713         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1714         _me="devfs_set_ruleset"
1715
1716         if [ -z "$rs" ]; then
1717                 warn "$_me: you must specify a ruleset number"
1718                 return 1
1719         fi
1720         debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1721         if ! /sbin/devfs $devdir ruleset $rs; then
1722                 warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1723                 return 1
1724         fi
1725         return 0
1726 }
1727
1728 # devfs_apply_ruleset ruleset [dir]
1729 #       Apply ruleset number $ruleset to the devfs mountpoint $dir.
1730 #       The ruleset argument must be a ruleset name as specified
1731 #       in a devfs.rules(5) file.  Returns 0 on success or non-zero
1732 #       if it could not apply the ruleset.
1733 #
1734 devfs_apply_ruleset()
1735 {
1736         local devdir rs _me
1737         [ -n "$1" ] && eval rs=\$$1 || rs=
1738         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1739         _me="devfs_apply_ruleset"
1740
1741         if [ -z "$rs" ]; then
1742                 warn "$_me: you must specify a ruleset"
1743                 return 1
1744         fi
1745         debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1746         if ! /sbin/devfs $devdir rule -s $rs applyset; then
1747                 warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1748                 return 1
1749         fi
1750         return 0
1751 }
1752
1753 # devfs_domount dir [ruleset]
1754 #       Mount devfs on dir. If ruleset is specified it is set
1755 #       on the mount-point. It must also be a ruleset name as specified
1756 #       in a devfs.rules(5) file. Returns 0 on success.
1757 #
1758 devfs_domount()
1759 {
1760         local devdir rs _me
1761         devdir="$1"
1762         [ -n "$2" ] && rs=$2 || rs=
1763         _me="devfs_domount()"
1764
1765         if [ -z "$devdir" ]; then
1766                 warn "$_me: you must specify a mount-point"
1767                 return 1
1768         fi
1769         debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1770         if ! mount -t devfs dev "$devdir"; then
1771                 warn "$_me: Unable to mount devfs on $devdir"
1772                 return 1
1773         fi
1774         if [ -n "$rs" ]; then
1775                 devfs_init_rulesets
1776                 devfs_set_ruleset $rs $devdir
1777                 devfs -m $devdir rule applyset
1778         fi
1779         return 0
1780 }
1781
1782 # Provide a function for normalizing the mounting of memory
1783 # filesystems.  This should allow the rest of the code here to remain
1784 # as close as possible between 5-current and 4-stable.
1785 #   $1 = size
1786 #   $2 = mount point
1787 #   $3 = (optional) extra mdmfs flags
1788 mount_md()
1789 {
1790         if [ -n "$3" ]; then
1791                 flags="$3"
1792         fi
1793         /sbin/mdmfs $flags -s $1 ${mfs_type} $2
1794 }
1795
1796 # Code common to scripts that need to load a kernel module
1797 # if it isn't in the kernel yet. Syntax:
1798 #   load_kld [-e regex] [-m module] file
1799 # where -e or -m chooses the way to check if the module
1800 # is already loaded:
1801 #   regex is egrep'd in the output from `kldstat -v',
1802 #   module is passed to `kldstat -m'.
1803 # The default way is as though `-m file' were specified.
1804 load_kld()
1805 {
1806         local _loaded _mod _opt _re
1807
1808         while getopts "e:m:" _opt; do
1809                 case "$_opt" in
1810                 e) _re="$OPTARG" ;;
1811                 m) _mod="$OPTARG" ;;
1812                 *) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
1813                 esac
1814         done
1815         shift $(($OPTIND - 1))
1816         if [ $# -ne 1 ]; then
1817                 err 3 'USAGE: load_kld [-e regex] [-m module] file'
1818         fi
1819         _mod=${_mod:-$1}
1820         _loaded=false
1821         if [ -n "$_re" ]; then
1822                 if kldstat -v | egrep -q -e "$_re"; then
1823                         _loaded=true
1824                 fi
1825         else
1826                 if kldstat -q -m "$_mod"; then
1827                         _loaded=true
1828                 fi
1829         fi
1830         if ! $_loaded; then
1831                 if ! kldload "$1"; then
1832                         warn "Unable to load kernel module $1"
1833                         return 1
1834                 else
1835                         info "$1 kernel module loaded."
1836                 fi
1837         else
1838                 debug "load_kld: $1 kernel module already loaded."
1839         fi
1840         return 0
1841 }
1842
1843 # ltr str src dst [var]
1844 #       Change every $src in $str to $dst.
1845 #       Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
1846 #       awk(1). If var is non-NULL, set it to the result.
1847 ltr()
1848 {
1849         local _str _src _dst _out _com _var
1850         _str="$1"
1851         _src="$2"
1852         _dst="$3"
1853         _var="$4"
1854         _out=""
1855
1856         local IFS="${_src}"
1857         for _com in ${_str}; do
1858                 if [ -z "${_out}" ]; then
1859                         _out="${_com}"
1860                 else
1861                         _out="${_out}${_dst}${_com}"
1862                 fi
1863         done
1864         if [ -n "${_var}" ]; then
1865                 setvar "${_var}" "${_out}"
1866         else
1867                 echo "${_out}"
1868         fi
1869 }
1870
1871 # Creates a list of providers for GELI encryption.
1872 geli_make_list()
1873 {
1874         local devices devices2
1875         local provider mountpoint type options rest
1876
1877         # Create list of GELI providers from fstab.
1878         while read provider mountpoint type options rest ; do
1879                 case ":${options}" in
1880                 :*noauto*)
1881                         noauto=yes
1882                         ;;
1883                 *)
1884                         noauto=no
1885                         ;;
1886                 esac
1887
1888                 case ":${provider}" in
1889                 :#*)
1890                         continue
1891                         ;;
1892                 *.eli)
1893                         # Skip swap devices.
1894                         if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
1895                                 continue
1896                         fi
1897                         devices="${devices} ${provider}"
1898                         ;;
1899                 esac
1900         done < /etc/fstab
1901
1902         # Append providers from geli_devices.
1903         devices="${devices} ${geli_devices}"
1904
1905         for provider in ${devices}; do
1906                 provider=${provider%.eli}
1907                 provider=${provider#/dev/}
1908                 devices2="${devices2} ${provider}"
1909         done
1910
1911         echo ${devices2}
1912 }
1913
1914 # Originally, root mount hold had to be released before mounting
1915 # the root filesystem.  This delayed the boot, so it was changed
1916 # to only wait if the root device isn't readily available.  This
1917 # can result in rc scripts executing before all the devices - such
1918 # as graid(8), or USB disks - can be accessed.  This function can
1919 # be used to explicitly wait for root mount holds to be released.
1920 root_hold_wait()
1921 {
1922         local wait waited holders
1923
1924         waited=0
1925         while true; do
1926                 holders="$(sysctl -n vfs.root_mount_hold)"
1927                 if [ -z "${holders}" ]; then
1928                         break;
1929                 fi
1930                 if [ ${waited} -eq 0 ]; then
1931                         echo -n "Waiting ${root_hold_delay}s" \
1932                         "for the root mount holders: ${holders}"
1933                 else
1934                         echo -n .
1935                 fi
1936                 if [ ${waited} -ge ${root_hold_delay} ]; then
1937                         echo
1938                         break
1939                 fi
1940                 sleep 1
1941                 waited=$(($waited + 1))
1942         done
1943 }
1944
1945 # Find scripts in local_startup directories that use the old syntax
1946 #
1947 find_local_scripts_old() {
1948         zlist=''
1949         slist=''
1950         for dir in ${local_startup}; do
1951                 if [ -d "${dir}" ]; then
1952                         for file in ${dir}/[0-9]*.sh; do
1953                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1954                                     continue
1955                                 zlist="$zlist $file"
1956                         done
1957                         for file in ${dir}/[!0-9]*.sh; do
1958                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1959                                     continue
1960                                 slist="$slist $file"
1961                         done
1962                 fi
1963         done
1964 }
1965
1966 find_local_scripts_new() {
1967         local_rc=''
1968         for dir in ${local_startup}; do
1969                 if [ -d "${dir}" ]; then
1970                         for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
1971                                 case "$file" in
1972                                 *.sample) ;;
1973                                 *)      if [ -x "$file" ]; then
1974                                                 local_rc="${local_rc} ${file}"
1975                                         fi
1976                                         ;;
1977                                 esac
1978                         done
1979                 fi
1980         done
1981 }
1982
1983 # check_required_{before|after} command
1984 #       Check for things required by the command before and after its precmd,
1985 #       respectively.  The two separate functions are needed because some
1986 #       conditions should prevent precmd from being run while other things
1987 #       depend on precmd having already been run.
1988 #
1989 check_required_before()
1990 {
1991         local _f
1992
1993         case "$1" in
1994         start)
1995                 for _f in $required_vars; do
1996                         if ! checkyesno $_f; then
1997                                 warn "\$${_f} is not enabled."
1998                                 if [ -z "$rc_force" ]; then
1999                                         return 1
2000                                 fi
2001                         fi
2002                 done
2003
2004                 for _f in $required_dirs; do
2005                         if [ ! -d "${_f}/." ]; then
2006                                 warn "${_f} is not a directory."
2007                                 if [ -z "$rc_force" ]; then
2008                                         return 1
2009                                 fi
2010                         fi
2011                 done
2012
2013                 for _f in $required_files; do
2014                         if [ ! -r "${_f}" ]; then
2015                                 warn "${_f} is not readable."
2016                                 if [ -z "$rc_force" ]; then
2017                                         return 1
2018                                 fi
2019                         fi
2020                 done
2021                 ;;
2022         esac
2023
2024         return 0
2025 }
2026
2027 check_required_after()
2028 {
2029         local _f _args
2030
2031         case "$1" in
2032         start)
2033                 for _f in $required_modules; do
2034                         case "${_f}" in
2035                                 *~*)    _args="-e ${_f#*~} ${_f%%~*}" ;;
2036                                 *:*)    _args="-m ${_f#*:} ${_f%%:*}" ;;
2037                                 *)      _args="${_f}" ;;
2038                         esac
2039                         if ! load_kld ${_args}; then
2040                                 if [ -z "$rc_force" ]; then
2041                                         return 1
2042                                 fi
2043                         fi
2044                 done
2045                 ;;
2046         esac
2047
2048         return 0
2049 }
2050
2051 # check_jail mib
2052 #       Return true if security.jail.$mib exists and set to 1.
2053
2054 check_jail()
2055 {
2056         local _mib _v
2057
2058         _mib=$1
2059         if _v=$(${SYSCTL_N} "security.jail.$_mib" 2> /dev/null); then
2060                 case $_v in
2061                 1)      return 0;;
2062                 esac
2063         fi
2064         return 1
2065 }
2066
2067 # check_kern_features mib
2068 #       Return existence of kern.features.* sysctl MIB as true or
2069 #       false.  The result will be cached in $_rc_cache_kern_features_
2070 #       namespace.  "0" means the kern.features.X exists.
2071
2072 check_kern_features()
2073 {
2074         local _v
2075
2076         [ -n "$1" ] || return 1;
2077         eval _v=\$_rc_cache_kern_features_$1
2078         [ -n "$_v" ] && return "$_v";
2079
2080         if ${SYSCTL_N} kern.features.$1 > /dev/null 2>&1; then
2081                 eval _rc_cache_kern_features_$1=0
2082                 return 0
2083         else
2084                 eval _rc_cache_kern_features_$1=1
2085                 return 1
2086         fi
2087 }
2088
2089 # check_namevarlist var
2090 #       Return "0" if ${name}_var is reserved in rc.subr.
2091
2092 _rc_namevarlist="program chroot chdir env flags fib nice user group groups prepend"
2093 check_namevarlist()
2094 {
2095         local _v
2096
2097         for _v in $_rc_namevarlist; do
2098         case $1 in
2099         $_v)    return 0 ;;
2100         esac
2101         done
2102
2103         return 1
2104 }
2105
2106 # _echoonce var msg mode
2107 #       mode=0: Echo $msg if ${$var} is empty.
2108 #               After doing echo, a string is set to ${$var}.
2109 #
2110 #       mode=1: Echo $msg if ${$var} is a string with non-zero length.
2111 #
2112 _echoonce()
2113 {
2114         local _var _msg _mode
2115         eval _var=\$$1
2116         _msg=$2
2117         _mode=$3
2118
2119         case $_mode in
2120         1)      [ -n "$_var" ] && echo "$_msg" ;;
2121         *)      [ -z "$_var" ] && echo -n "$_msg" && eval "$1=finished" ;;
2122         esac
2123 }
2124
2125 # If the loader env variable rc.debug is set, turn on debugging. rc.conf will
2126 # still override this, but /etc/defaults/rc.conf can't unconditionally set this
2127 # since it would undo what we've done here.
2128 if kenv -q rc.debug > /dev/null ; then
2129         rc_debug=YES
2130 fi